import unittest
import sys


if __name__ == '__main__':
    cov = None
    if '--coverage' in sys.argv:
        import coverage
        cov = coverage.Coverage(source=['nclu'])
        cov.start()

    runner = unittest.TextTestRunner()
    loader = unittest.TestLoader()
    suite = unittest.TestSuite()
    suite.addTests(loader.discover('nclu.tests'))
    runner.run(suite)

    # restore patches now
    from nclu.tests.utils import get_patcher
    patcher = get_patcher()
    patcher.restore()

    if cov is not None:
        cov.stop()
        cov.save()
