from nclu.tests.base import BaseTest
from nclu.tests.utils import read_data_file


class TestLLDP(BaseTest):
    def test_net_show_lldp_table_output(self):
        from nclu import netshow2
        self.patcher.expect_command(
            '/sbin/bridge -j -c vlan show', '{}')
        self.patcher.expect_command(
            '/sbin/ip -o addr show',
            '''1: lo    inet 127.0.0.1/8 scope host lo\       valid_lft forever preferred_lft forever
1: lo    inet6 ::1/128 scope host \       valid_lft forever preferred_lft forever
2: eth0    inet 10.0.3.66/22 brd 10.0.3.255 scope global eth0\       valid_lft forever preferred_lft forever
2: eth0    inet6 fe80::2e0:ecff:fe27:68a9/64 scope link \       valid_lft forever preferred_lft forever
''')
        output = netshow2.lldp_json_to_table(
            read_data_file('net/show/lldp/basic.json'))
        self.assertTrue(
            'eth0       N/A    Mgmt           '
            'pioneerMS7.mvlab.cumulusnetworks.com  swp43 desc' in output
        )
        self.assertIn(
            'swp6       N/A    NotConfigured  '
            'host-114                              swp1 desc',
            output)
        self.assertIn(
            'eth0       N/A    Mgmt           '
            'pioneerMS7.mvlab.cumulusnetworks.com  swp43 desc', output
        )
